/* ***** BEGIN LICENSE BLOCK *****
 * Version: GPL 2.0
 *
 * This code is part of DownThemAll! - dTa!
 * Copyright © 2004-2006 Federico Parodi and Stefano Verna.
 * 
 * See notice.txt and gpl.txt for details.
 *
 * ***** END LICENSE BLOCK ***** */

var dropDowns = new Object();
var strbundleB, strbundle;

function downloadElement(url, num, refPage) {
	this.url = url;
	this.numIstance = num;
	this.refPage = refPage;
	
	this.description = "";
	this.ultDescription = "";
	this.mask;
	this.dirSave;
}

function checkSyntax() {
	
	// let's check and create the directory
	var f = new filePicker();
	var directory = document.getElementById("directory");
	if (!directory.value || directory.value.trim().length == 0) return false;
	
	if (f.createValidDestination(directory.value)==false) {
		alert(strbundleB.getString("destination"));
		var newDir = f.getFolder();
		if (!newDir) 
			directory.value="";
		else
			directory.value = newDir;
		return false;
	}
	dropDowns.directory.saveCurrent(false);
	return true;
}

function addURLnow(start) {

		var url = document.getElementById("URLaddress").value;
		var ref = document.getElementById("URLref").value;
		
    if (url.isLinkOpenable() && checkSyntax()) {
			var num = Preferences.get("extensions.dta.numistance", 1);
			num = (num<999)?(++num):1;
			Preferences.set("extensions.dta.numistance", num);
			
			var el = new downloadElement(document.getElementById("URLaddress").value, num, document.getElementById("URLref").value)
			el.dirSave = dropDowns.directory.getCurrent();
			el.mask = dropDowns.renaming.getCurrent();
			
			if (window.arguments)
				el.description = window.arguments[1].description;
		
			DTA_AddingFunctions.sendToDown(start, [el]);
			dropDowns.directory.saveCurrent(true);
			dropDowns.renaming.saveCurrent(true);
			
			window.close();
    } else {
			alert(strbundleB.getString("correctness"));
    }
}

function load() {try {
		strbundleB = document.getElementById("strings");
		strbundle = document.getElementById("string");
		
		document.getElementById("directory").addEventListener("blur", checkSyntax, true);
		
		dropDowns.renaming = new dropDownObject("renaming", "renaming", "renamingitems", "*name*.*ext*", "*name*.*ext*|@|*num*_*name*.*ext*|@|*url*/*name*.*ext*|@|*name* (*text*).*ext*|@|*name* (*hh*-*mm*).*ext*");
		dropDowns.renaming.load();
		dropDowns.directory = new dropDownObject("directory", "directory", "directoryitems", "", "");
		dropDowns.directory.load();
		
		// if we know the file to download
		if (window.arguments) {
			var e = window.arguments[1];
			var turbo = window.arguments[0];
			document.getElementById("URLaddress").value = e.url;
			document.getElementById("URLref").value = (new String(e.refPage).isLinkOpenable())?e.refPage:"";
			if (turbo) addURLnow(turbo);
		} else {
			// check if there's some URL in clipboard
			var clip = Components.classes["@mozilla.org/widget/clipboard;1"].getService(Components.interfaces.nsIClipboard);
			var trans = Components.classes["@mozilla.org/widget/transferable;1"].createInstance(Components.interfaces.nsITransferable);
			trans.addDataFlavor("text/unicode");
			clip.getData(trans, clip.kGlobalClipboard);
			var str=new Object();
			var strLength=new Object();
			trans.getTransferData("text/unicode",str,strLength);
			if (str) {
				str=str.value.QueryInterface(Components.interfaces.nsISupportsString);
				pastetext=str.data.substring(0,strLength.value / 2);
				if (pastetext.length > 0 && (/^(http|ftp)/).test(pastetext)) {
					document.getElementById("URLaddress").value = pastetext;
					document.getElementById("URLaddress").select();
				}
			}
		}
		
	} catch(e) {
	Debug.dump("load():", e);
	}
}

function browseDire() {
	// let's check and create the directory
	var f = new filePicker();
	var newDir = f.getFolder(document.getElementById("directory").value);
	if (newDir) document.getElementById("directory").value = newDir;
	
	var directory = document.getElementById("directory");
	checkSyntax();
	dropDowns.directory.saveCurrent(false);
}

function appendTag(event) {
	var text = document.getElementById(dropDowns.renaming.idInput);
	var s = text.inputField.selectionStart;
	text.value = text.value.substring(0, s) + event.target.getAttribute("value") + text.value.substring(text.inputField.selectionEnd, text.value.length);
	text.inputField.setSelectionRange(s + event.target.getAttribute("value").length, s + event.target.getAttribute("value").length);
}

var listObserver = {
  onDragStart: function (evt,transferData,action){
    var txt=evt.target.getAttribute("value");
    transferData.data=new TransferData();
    transferData.data.addDataForFlavour("text/unicode", txt);
  }
}

function unload() {
}

window.addEventListener("load", function() {setTimeout("window.sizeToContent();",0);}, false);
